  
#ifndef _flagger_cmpt_h_
#define _flagger_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>
#include <tools/flagging/flagger_forward.h>

using namespace std;

namespace casac {
           


   class  flagger  {
       public :
flagger();
         ~flagger();
         bool open(const  string& msname=string(""));
         bool setdata(const  string& field=string(""), const  string& spw=string(""), const  string& array=string(""), const  string& feed=string(""), const  string& scan=string(""), const  string& baseline=string(""), const  string& uvrange=string(""), const  string& time=string(""), const  string& correlation=string(""), const  string& intent=string(""), const  string& observation=string(""));
         bool setmanualflags(const  string& field=string(""), const  string& spw=string(""), const  string& array=string(""), const  string& feed=string(""), const  string& scan=string(""), const  string& baseline=string(""), const  string& uvrange=string(""), const  string& time=string(""), const  string& correlation=string(""), const  string& intent=string(""), const  string& observation=string(""),  bool  autocorrelation=false,  bool  unflag=false, const  string& clipexpr=string(""),  const std::vector<double>& cliprange=initialize_vector(2,(double)0, (double)0), const  string& clipcolumn=string("DATA"),  bool  outside=true,  bool  channelavg=false, 
			  double quackinterval=0.0, const  string& quackmode=string("beg"),  bool  quackincrement=false);
         bool printflagselection();
         bool clearflagselection( int  index=0);
         record* getautoflagparams(const  string& algorithm=string("none"));
         bool setautoflag(const  string& algorithm=string("none"),  const record& parameters=initialize_record("") );
         bool setshadowflags(const  string& field=string(""), const  string& spw=string(""), const  string& array=string(""), const  string& feed=string(""), const  string& scan=string(""), const  string& baseline=string(""), const  string& uvrange=string(""), const  string& time=string(""), const  string& correlation=string(""), const  string& intent=string(""), const  string& observation=string(""), 
			  double diameter=-1.0);
         bool setelevationflags(const  string& field=string(""), const  string& spw=string(""), const  string& array=string(""), const  string& feed=string(""), const  string& scan=string(""), const  string& baseline=string(""), const  string& uvrange=string(""), const  string& time=string(""), const  string& correlation=string(""), const  string& intent=string(""), const  string& observation=string(""), 
			  double lowerlimit=0.0, 
			  double upperlimit=90.0);
         bool setflagsummary(const  string& field=string(""), const  string& spw=string(""), const  string& array=string(""), const  string& feed=string(""), const  string& scan=string(""), const  string& baseline=string(""), const  string& uvrange=string(""), const  string& time=string(""), const  string& correlation=string(""), const  string& intent=string(""), const  string& observation=string(""));
         bool setqueryflag(const  string& field=string(""), const  string& spw=string(""), const  string& array=string(""), const  string& feed=string(""), const  string& scan=string(""), const  string& baseline=string(""), const  string& uvrange=string(""), const  string& time=string(""), const  string& correlation=string(""), const  string& intent=string(""), const  string& observation=string(""), const  string& what=string("fieldid"), 
			  double fractionthreshold=0.0,  int  nflagsthreshold=0,  bool  morethan=true);
         bool setextendflag(const  string& field=string(""), const  string& spw=string(""), const  string& array=string(""), const  string& feed=string(""), const  string& scan=string(""), const  string& baseline=string(""), const  string& uvrange=string(""), const  string& time=string(""), const  string& correlation=string(""), const  string& intent=string(""), const  string& observation=string(""), const  string& along=string("allbaselines"),  int  width=0);
         record* run( bool  trial=false,  bool  reset=false);
         bool writeflagstodisk();
         bool help(const  string& names=string(""));
         bool done();
         bool saveflagversion(const  string& versionname=string(""), const  string& comment=string(""), const  string& merge=string(""));
         bool restoreflagversion( const std::vector<std::string>& versionname=std::vector<string>(1, ""), const  string& merge=string(""));
         bool deleteflagversion( const std::vector<std::string>& versionname=std::vector<string>(1, ""));
         std::vector<std::string> getflagversionlist( bool  printflags=true);

      private :
#include <tools/flagging/flagger_private.h>
   }; 

 
}
#endif
