  
#ifndef _lightflagger_cmpt_h_
#define _lightflagger_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>
#include <tools/flagging/lightflagger_forward.h>

using namespace std;

namespace casac {
           


   class  lightflagger  {
       public :
lightflagger();
         ~lightflagger();
         bool open(const  string& msname=string(""));
         bool setdata(const  string& field=string(""), const  string& spw=string(""), const  string& array=string(""), const  string& feed=string(""), const  string& scan=string(""), const  string& baseline=string(""), const  string& uvrange=string(""), const  string& time=string(""), const  string& correlation=string(""));
         record* getparameters(const  string& algorithm=string("none"));
         bool setparameters(const  string& algorithm=string("none"),  const record& parameters=initialize_record("") );
         record* run( const record& parameters=initialize_record("") );
         bool done();
         bool saveflagversion(const  string& versionname=string(""), const  string& comment=string(""), const  string& merge=string(""));
         bool restoreflagversion( const std::vector<std::string>& versionname=std::vector<string>(1, ""), const  string& merge=string(""));
         bool deleteflagversion( const std::vector<std::string>& versionname=std::vector<string>(1, ""));
         std::vector<std::string> getflagversionlist( bool  printflags=true);

      private :
#include <tools/flagging/lightflagger_private.h>
   }; 

 
}
#endif
